# dmxstat.c File Reference

`#include "dmx.h"`
`#include "dmxstat.h"`
`#include "dmxlog.h"`
`#include <X11/Xos.h>`

## Data Structures

struct | _DMXStatAvg
struct | _DMXStatInfo

## Typedefs

typedef struct _DMXStatAvg | DMXStatAvg

## Functions

static unsigned long | usec (struct timeval *stop, struct timeval *start)
static unsigned long | avg (DMXStatAvg *data, unsigned long *max)
void | dmxStatActivate (const char *interval, const char *displays)
DMXStatInfo * | dmxStatAlloc (void)
void | dmxStatFree (DMXStatInfo *pt)
static void | dmxStatValue (DMXStatAvg *data, unsigned long value)
void | dmxStatSync (DMXScreenInfo *dmxScreen, struct timeval *stop, struct timeval *start, unsigned long pending)
static CARD32 | dmxStatCallback (OsTimerPtr timer, CARD32 t, pointer arg)
void | dmxStatInit (void)

## Variables

int | dmxStatInterval
static int | dmxStatDisplays
static OsTimerPtr | dmxStatTimer

## Detailed Description

The DMX server code is written to call dmxSync() whenever an XSync() might be necessary. However, since XSync() requires a two way communication with the other X server, eliminating unnecessary XSync() calls is a key performance optimization. Support for this optimization is provided in dmxsync.c. This file provides routines that evaluate this optimization by counting the number of XSync() calls and monitoring their latency. This functionality can be turned on using the -stat command-line parameter.

## Typedef Documentation

typedef struct _DMXStatAvg DMXStatAvg

Used to compute a running average of value.

## Function Documentation

static unsigned long avg | ( | DMXStatAvg * | data,
|  | unsigned long * | max |
| ) |  |  | `[static]`

References _DMXStatAvg::count, and _DMXStatAvg::value.

Referenced by dmxStatCallback().

void dmxStatActivate | ( | const char * | interval,
|  | const char * | displays |
| ) |  |  |

Turn on XSync statistic gathering and printing. Print every interval seconds, with lines for the first displays. If interval is NULL, 1 will be used. If displays is NULL, 0 will be used (meaning a line for every display will be printed). Note that this function takes string arguments because it will usually be called from ddxProcessArgument in dmxinit.c.

References dmxStatDisplays, and dmxStatInterval.

Referenced by ddxProcessArgument().

DMXStatInfo* dmxStatAlloc | ( | void |  | ) |

Allocate a DMXStatInfo structure.

Referenced by dmxConfigAddDisplay().

static CARD32 dmxStatCallback | ( | OsTimerPtr | timer,
|  | CARD32 | t,
|  | pointer | arg |
| ) |  |  | `[static]`

References avg(), _DMXStatInfo::bins, dmxDebug, dmxLog(), dmxLogCont(), dmxNumScreens, dmxScreens, dmxStatDisplays, dmxStatInterval, _DMXStatInfo::oldSyncCount, _DMXStatInfo::pending, _DMXScreenInfo::stat, _DMXStatInfo::syncCount, and _DMXStatInfo::usec.

Referenced by dmxStatInit().

void dmxStatFree | ( | DMXStatInfo * | pt | ) |

Free the memory used by a DMXStatInfo structure.

Referenced by InitOutput().

void dmxStatInit | ( | void |  | ) |

Try to initialize the statistic gathering and printing routines. Initialization only takes place if dmxStatActivate has already been called. We don't need the same generation protection that we used in dmxSyncInit because our timer is always on a queue -- hence, server generation will always free it.

References dmxStatCallback(), dmxStatInterval, and dmxStatTimer.

Referenced by InitOutput().

void dmxStatSync | ( | DMXScreenInfo * | dmxScreen,
|  | struct timeval * | stop,
|  | struct timeval * | start,
|  | unsigned long | pending |
| ) |  |  |

Note that a XSync() was just done on dmxScreen with the start and stop times (from gettimeofday()) and the number of pending-but-not-yet-processed XSync requests. This routine is called from dmxDoSync in dmxsync.c

References _DMXStatInfo::bins, DMX_STAT_BIN0, DMX_STAT_BINS, dmxStatValue(), _DMXStatInfo::pending, _DMXScreenInfo::stat, _DMXStatInfo::syncCount, _DMXStatInfo::usec, and usec().

Referenced by dmxDoSync().

static void dmxStatValue | ( | DMXStatAvg * | data,
|  | unsigned long | value |
| ) |  |  | `[static]`

References _DMXStatAvg::count, DMX_STAT_LENGTH, _DMXStatAvg::pos, and _DMXStatAvg::value.

Referenced by dmxStatSync().

static unsigned long usec | ( | struct timeval * | stop,
|  | struct timeval * | start |
| ) |  |  | `[static]`

Return the number of microseconds as an unsigned long. Unfortunately, this is only useful for intervals < about 4 sec.

Referenced by dmxStatSync().

## Variable Documentation

int dmxStatDisplays`[static]`

Referenced by dmxStatActivate(), and dmxStatCallback().

int dmxStatInterval

Only for dmxstat.c and dmxsync.c

Referenced by dmxDoSync(), dmxStatActivate(), dmxStatCallback(), and dmxStatInit().

OsTimerPtr dmxStatTimer`[static]`

Referenced by dmxStatInit().

Generated June 29, 2004 for Distributed Multihead X by doxygen 1.3.4. </addres>